const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const curriculum_subjects = sequelize.define(
    'curriculum_subjects',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

subject_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"math",


"ela",


"spanish",


"stem",


"bible",


"arts",


"music",


"dance",


"cooking",


"drama",


"choir",


"leadership"

        ],

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  curriculum_subjects.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

























    db.curriculum_subjects.hasMany(db.staff_assignments, {
      as: 'staff_assignments_subject',
      foreignKey: {
          name: 'subjectId',
      },
      constraints: false,
    });




//end loop






    db.curriculum_subjects.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.curriculum_subjects.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return curriculum_subjects;
};


